package com.lantone.qc.trans.taizhou;

import com.google.common.collect.Lists;
import com.lantone.qc.pub.model.doc.InvasiveOperationDoc;
import com.lantone.qc.pub.model.vo.MedrecVo;
import com.lantone.qc.trans.ModelDocTrans;
import com.lantone.qc.trans.comsis.OrdinaryAssistant;
import com.lantone.qc.dbanaly.facade.taizhou.TzXmlUtil;

import java.util.List;
import java.util.Map;

/**
 * @Description: 有创操作记录文档生成
 * @author: rengb
 * @time: 2020/3/17 13:27
 */
public class TaiZhouInvasiveOperationDocTrans extends ModelDocTrans {

    @Override
    public List<InvasiveOperationDoc> extract(MedrecVo medrecVo) {
        List<InvasiveOperationDoc> retList = Lists.newArrayList();
        List<Map<String, Object>> contentMaps = (List) medrecVo.getContent().get("content");
        contentMaps.forEach(contentMap -> {
            retList.add(getInvasiveOperationDoc(contentMap));
        });
        return retList;
    }

    private InvasiveOperationDoc getInvasiveOperationDoc(Map<String, Object> contentMap) {
        String content = contentMap.get("xmlText").toString();
        Map<String, String> xmlNodeValueMap = TzXmlUtil.getXmlToMapForTZ(content);
        xmlNodeValueMap.put("mode_id=" + contentMap.get("modeId").toString(), "");
        xmlNodeValueMap.put("rec_title=" + contentMap.get("recTitle").toString(), "");
        Map<String, String> structureMap = OrdinaryAssistant.mapKeyContrast(xmlNodeValueMap, keyContrasts);

        InvasiveOperationDoc invasiveOperationDoc = new InvasiveOperationDoc();
        invasiveOperationDoc.setStructureMap(structureMap);

        return invasiveOperationDoc;
    }

    private List<String> keyContrasts = Lists.newArrayList();

}